package org.hibernate.test.annotations.propertyref;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.hibernate.Session;
import org.hibernate.cfg.Configuration;
import org.hibernate.cfg.Environment;
import org.hibernate.jdbc.Work;
import org.hibernate.test.annotations.TestCase;

/**
 * @author Steve Ebersole
 */
public class DoesNotWorkTest extends TestCase {
	@Override
	protected Class<?>[] getAnnotatedClasses() {
		return new Class[] {DoesNotWork.class};
	}

	@Override
	protected void configure(Configuration configuration) {
		super.configure( configuration );
		configuration.setProperty( Environment.USE_SECOND_LEVEL_CACHE, "false" );
		configuration.setProperty( Environment.HBM2DDL_IMPORT_FILES, "/org/hibernate/test/annotations/propertyref/import.sql" );
	}

	public void testIt() {
		DoesNotWorkPk pk = new DoesNotWorkPk();
		pk.setId1( "ZZZ" );
		pk.setId2( "00" );

//		{
//			Session session = openSession();
//			session.beginTransaction();
//			DoesNotWork entity = new DoesNotWork( pk );
//			entity.setGlobalNotes( Arrays.asList( "My first note!" ) );
//			session.save( entity );
//			session.getTransaction().commit();
//			session.close();
//		}

		{
			Session session = openSession();
			session.beginTransaction();
			DoesNotWork entity = (DoesNotWork) session.get( DoesNotWork.class, pk );
			List<String> notes = entity.getGlobalNotes();
			if ( notes != null && notes.size() > 0 ) {
				for ( String note : notes ) {
					System.out.println( note );
				}
			}
			session.delete( entity );
			session.getTransaction().commit();
			session.close();
		}
	}
}
